#!/usr/bin/python
#
# Copyright 2018-2022 Polyaxon, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# coding: utf-8

"""
    Polyaxon SDKs and REST API specification.

    Polyaxon SDKs and REST API specification.  # noqa: E501

    The version of the OpenAPI document: 1.18.0
    Contact: contact@polyaxon.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from polyaxon_sdk.configuration import Configuration


class V1EntityStageBodyRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'owner': 'str',
        'entity': 'str',
        'kind': 'str',
        'name': 'str',
        'condition': 'V1StageCondition'
    }

    attribute_map = {
        'owner': 'owner',
        'entity': 'entity',
        'kind': 'kind',
        'name': 'name',
        'condition': 'condition'
    }

    def __init__(self, owner=None, entity=None, kind=None, name=None, condition=None, local_vars_configuration=None):  # noqa: E501
        """V1EntityStageBodyRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._owner = None
        self._entity = None
        self._kind = None
        self._name = None
        self._condition = None
        self.discriminator = None

        if owner is not None:
            self.owner = owner
        if entity is not None:
            self.entity = entity
        if kind is not None:
            self.kind = kind
        if name is not None:
            self.name = name
        if condition is not None:
            self.condition = condition

    @property
    def owner(self):
        """Gets the owner of this V1EntityStageBodyRequest.  # noqa: E501


        :return: The owner of this V1EntityStageBodyRequest.  # noqa: E501
        :rtype: str
        """
        return self._owner

    @owner.setter
    def owner(self, owner):
        """Sets the owner of this V1EntityStageBodyRequest.


        :param owner: The owner of this V1EntityStageBodyRequest.  # noqa: E501
        :type owner: str
        """

        self._owner = owner

    @property
    def entity(self):
        """Gets the entity of this V1EntityStageBodyRequest.  # noqa: E501


        :return: The entity of this V1EntityStageBodyRequest.  # noqa: E501
        :rtype: str
        """
        return self._entity

    @entity.setter
    def entity(self, entity):
        """Sets the entity of this V1EntityStageBodyRequest.


        :param entity: The entity of this V1EntityStageBodyRequest.  # noqa: E501
        :type entity: str
        """

        self._entity = entity

    @property
    def kind(self):
        """Gets the kind of this V1EntityStageBodyRequest.  # noqa: E501


        :return: The kind of this V1EntityStageBodyRequest.  # noqa: E501
        :rtype: str
        """
        return self._kind

    @kind.setter
    def kind(self, kind):
        """Sets the kind of this V1EntityStageBodyRequest.


        :param kind: The kind of this V1EntityStageBodyRequest.  # noqa: E501
        :type kind: str
        """

        self._kind = kind

    @property
    def name(self):
        """Gets the name of this V1EntityStageBodyRequest.  # noqa: E501


        :return: The name of this V1EntityStageBodyRequest.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this V1EntityStageBodyRequest.


        :param name: The name of this V1EntityStageBodyRequest.  # noqa: E501
        :type name: str
        """

        self._name = name

    @property
    def condition(self):
        """Gets the condition of this V1EntityStageBodyRequest.  # noqa: E501


        :return: The condition of this V1EntityStageBodyRequest.  # noqa: E501
        :rtype: V1StageCondition
        """
        return self._condition

    @condition.setter
    def condition(self, condition):
        """Sets the condition of this V1EntityStageBodyRequest.


        :param condition: The condition of this V1EntityStageBodyRequest.  # noqa: E501
        :type condition: V1StageCondition
        """

        self._condition = condition

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1EntityStageBodyRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, V1EntityStageBodyRequest):
            return True

        return self.to_dict() != other.to_dict()
